diff --git a/doc/man/dc_datetime_gmtime.3 b/doc/man/dc_datetime_gmtime.3
index e69de29..01780fc 100644
--- a/doc/man/dc_datetime_gmtime.3
+++ b/doc/man/dc_datetime_gmtime.3
@@ -0,0 +1,95 @@
+.\"
+.\" libdivecomputer
+.\"
+.\" Copyright (C) 2017 Kristaps Dzonsons <kristaps@bsd.lv>
+.\"
+.\" This library is free software; you can redistribute it and/or
+.\" modify it under the terms of the GNU Lesser General Public
+.\" License as published by the Free Software Foundation; either
+.\" version 2.1 of the License, or (at your option) any later version.
+.\"
+.\" This library is distributed in the hope that it will be useful,
+.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
+.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+.\" Lesser General Public License for more details.
+.\"
+.\" You should have received a copy of the GNU Lesser General Public
+.\" License along with this library; if not, write to the Free Software
+.\" Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+.\" MA 02110-1301 USA
+.\"
+.Dd January 11, 2017
+.Dt DC_DATETIME_GMTIME 3
+.Os
+.Sh NAME
+.Nm dc_datetime_gmtime
+.Nd convert an timestamp to GMT date and time
+.Sh LIBRARY
+.Lb libdivecomputer
+.Sh SYNOPSIS
+.In libdivecomputer/datetime.h
+.Ft dc_datetime_t *
+.Fo dc_datetime_gmtime
+.Fa "dc_datetime_t *result"
+.Fa "dc_ticks_t ticks"
+.Fc
+.Sh DESCRIPTION
+Convert an integral timestamp
+.Fa ticks
+created with
+.Xr dc_datetime_now 3
+or
+.Xr dc_datetime_mktime 3
+into a broken-down GMT representation in
+.Fa result .
+The filled-in value consists of the
+.Va year ,
+.Va month ,
+.Va day ,
+.Va hour ,
+.Va minute ,
+and
+.Va second
+fields.
+.Pp
+.Em Note :
+unlike in
+.Vt "struct tm" ,
+the value for
+.Va year
+is normalised, not less 1900; moreover, the value for
+.Va month
+is from one, not zero.
+.Sh RETURN VALUES
+This returns the
+.Fa result
+pointer on success.
+It returns
+.Dv NULL
+if
+.Fa ticks
+cannot be sanely converted or if
+.Fa result
+is
+.Dv NULL .
+.Sh SEE ALSO
+.Xr dc_datetime_localtime 3 ,
+.Xr dc_datetime_mktime 3 ,
+.Xr dc_datetime_new 3
+.Sh AUTHORS
+The
+.Lb libdivecomputer
+library was written by
+.An Jef Driesen ,
+.Mt jef@libdivecomputer.org .
+The manpages were written by
+.An Kristaps Dzonsons ,
+.Mt kristaps@bsd.lv .
+.Sh CAVEATS
+The
+.Nm
+function may internally invoke
+.Xr gmtime 3
+or
+.Xr gmtime_r 3 ,
+either of which might interact with the file-system in unexpected ways.
diff --git a/doc/man/dc_datetime_localtime.3 b/doc/man/dc_datetime_localtime.3
index e69de29..b6c7903 100644
--- a/doc/man/dc_datetime_localtime.3
+++ b/doc/man/dc_datetime_localtime.3
@@ -0,0 +1,95 @@
+.\"
+.\" libdivecomputer
+.\"
+.\" Copyright (C) 2017 Kristaps Dzonsons <kristaps@bsd.lv>
+.\"
+.\" This library is free software; you can redistribute it and/or
+.\" modify it under the terms of the GNU Lesser General Public
+.\" License as published by the Free Software Foundation; either
+.\" version 2.1 of the License, or (at your option) any later version.
+.\"
+.\" This library is distributed in the hope that it will be useful,
+.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
+.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+.\" Lesser General Public License for more details.
+.\"
+.\" You should have received a copy of the GNU Lesser General Public
+.\" License along with this library; if not, write to the Free Software
+.\" Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+.\" MA 02110-1301 USA
+.\"
+.Dd January 11, 2017
+.Dt DC_DATETIME_LOCALTIME 3
+.Os
+.Sh NAME
+.Nm dc_datetime_localtime
+.Nd convert an timestamp to local date and time
+.Sh LIBRARY
+.Lb libdivecomputer
+.Sh SYNOPSIS
+.In libdivecomputer/datetime.h
+.Ft dc_datetime_t *
+.Fo dc_datetime_localtime
+.Fa "dc_datetime_t *result"
+.Fa "dc_ticks_t ticks"
+.Fc
+.Sh DESCRIPTION
+Convert an integral timestamp
+.Fa ticks
+created with
+.Xr dc_datetime_now 3
+or
+.Xr dc_datetime_mktime 3
+into a broken-down local-time representation in
+.Fa result .
+The filled-in value consists of the
+.Va year ,
+.Va month ,
+.Va day ,
+.Va hour ,
+.Va minute ,
+and
+.Va second
+fields.
+.Pp
+.Em Note :
+unlike in
+.Vt "struct tm" ,
+the value for
+.Va year
+is normalised, not less 1900; moreover, the value for
+.Va month
+is from one, not zero.
+.Sh RETURN VALUES
+This returns the
+.Fa result
+pointer on success.
+It returns
+.Dv NULL
+if
+.Fa ticks
+cannot be sanely converted or if
+.Fa result
+is
+.Dv NULL .
+.Sh SEE ALSO
+.Xr dc_datetime_gmtime 3 ,
+.Xr dc_datetime_mktime 3 ,
+.Xr dc_datetime_new 3
+.Sh AUTHORS
+The
+.Lb libdivecomputer
+library was written by
+.An Jef Driesen ,
+.Mt jef@libdivecomputer.org .
+The manpages were written by
+.An Kristaps Dzonsons ,
+.Mt kristaps@bsd.lv .
+.Sh CAVEATS
+The
+.Nm
+function may internally invoke
+.Xr localtime 3
+or
+.Xr localtime_r 3 ,
+either of which might interact with the file-system in unexpected ways.
diff --git a/doc/man/dc_datetime_mktime.3 b/doc/man/dc_datetime_mktime.3
index e69de29..7124791 100644
--- a/doc/man/dc_datetime_mktime.3
+++ b/doc/man/dc_datetime_mktime.3
@@ -0,0 +1,60 @@
+.\"
+.\" libdivecomputer
+.\"
+.\" Copyright (C) 2017 Kristaps Dzonsons <kristaps@bsd.lv>
+.\"
+.\" This library is free software; you can redistribute it and/or
+.\" modify it under the terms of the GNU Lesser General Public
+.\" License as published by the Free Software Foundation; either
+.\" version 2.1 of the License, or (at your option) any later version.
+.\"
+.\" This library is distributed in the hope that it will be useful,
+.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
+.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+.\" Lesser General Public License for more details.
+.\"
+.\" You should have received a copy of the GNU Lesser General Public
+.\" License along with this library; if not, write to the Free Software
+.\" Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+.\" MA 02110-1301 USA
+.\"
+.Dd January 11, 2017
+.Dt DC_DATETIME_MKTIME 3
+.Os
+.Sh NAME
+.Nm dc_datetime_mktime
+.Nd convert an local date and time to a timestamp
+.Sh LIBRARY
+.Lb libdivecomputer
+.Sh SYNOPSIS
+.In libdivecomputer/datetime.h
+.Ft dc_ticks_t
+.Fo dc_datetime_mktime
+.Fa "const dc_datetime_t *dt"
+.Fc
+.Sh DESCRIPTION
+Convert a broken-down local date and time created with
+.Xr dc_datetime_localtime 3
+into an integral timestamp.
+.Sh RETURN VALUES
+This returns the integral time-stamp or -1 if the given date and time
+may not sanely be converted.
+.Sh SEE ALSO
+.Xr dc_datetime_gmtime 3 ,
+.Xr dc_datetime_localtime 3 ,
+.Xr dc_datetime_new 3
+.Sh AUTHORS
+The
+.Lb libdivecomputer
+library was written by
+.An Jef Driesen ,
+.Mt jef@libdivecomputer.org .
+The manpages were written by
+.An Kristaps Dzonsons ,
+.Mt kristaps@bsd.lv .
+.Sh CAVEATS
+The
+.Nm
+function may internally invoke
+.Xr mktime 3 ,
+which might interact with the file-system in unexpected ways.
diff --git a/doc/man/dc_datetime_now.3 b/doc/man/dc_datetime_now.3
index e69de29..1e9273a 100644
--- a/doc/man/dc_datetime_now.3
+++ b/doc/man/dc_datetime_now.3
@@ -0,0 +1,50 @@
+.\"
+.\" libdivecomputer
+.\"
+.\" Copyright (C) 2017 Kristaps Dzonsons <kristaps@bsd.lv>
+.\"
+.\" This library is free software; you can redistribute it and/or
+.\" modify it under the terms of the GNU Lesser General Public
+.\" License as published by the Free Software Foundation; either
+.\" version 2.1 of the License, or (at your option) any later version.
+.\"
+.\" This library is distributed in the hope that it will be useful,
+.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
+.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+.\" Lesser General Public License for more details.
+.\"
+.\" You should have received a copy of the GNU Lesser General Public
+.\" License along with this library; if not, write to the Free Software
+.\" Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+.\" MA 02110-1301 USA
+.\"
+.Dd January 11, 2017
+.Dt DC_DATETIME_NOW 3
+.Os
+.Sh NAME
+.Nm dc_datetime_now
+.Nd return the current integral timestamp
+.Sh LIBRARY
+.Lb libdivecomputer
+.Sh SYNOPSIS
+.In libdivecomputer/datetime.h
+.Ft dc_ticks_t
+.Fo dc_datetime_now
+.Fc
+.Sh DESCRIPTION
+Get the current system timestamp as an integral value.
+.Sh RETURN VALUES
+This always returns the system time.
+.Sh SEE ALSO
+.Xr dc_datetime_gmtime 3 ,
+.Xr dc_datetime_localtime 3 ,
+.Xr dc_datetime_mktime 3
+.Sh AUTHORS
+The
+.Lb libdivecomputer
+library was written by
+.An Jef Driesen ,
+.Mt jef@libdivecomputer.org .
+The manpages were written by
+.An Kristaps Dzonsons ,
+.Mt kristaps@bsd.lv .